package com.zxhy.hfilemanagermaster.video

import android.app.Dialog
import android.os.Bundle
import android.view.View
import androidx.activity.enableEdgeToEdge
import androidx.appcompat.app.AppCompatActivity
import androidx.core.content.ContextCompat
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.GridLayoutManager
import com.example.hfilemanagermaster.R
import com.example.hfilemanagermaster.databinding.ActivityVideoBinding
import com.zxhy.hfilemanagermaster.data.MediaDataC
import com.zxhy.hfilemanagermaster.dialog.showLoadingDialog
import com.zxhy.hfilemanagermaster.dialog.showOperationDialog
import com.zxhy.hfilemanagermaster.knife.deleteDirectory
import com.zxhy.hfilemanagermaster.knife.toast
import com.zxhy.hfilemanagermaster.knife.videoFile
import com.zxhy.hfilemanagermaster.permission.IntentLauncher
import com.zxhy.hfilemanagermaster.permission.PermissionLauncher
import com.zxhy.hfilemanagermaster.permission.alert
import com.zxhy.hfilemanagermaster.permission.requestStoreFollow
import com.zxhy.hfilemanagermaster.permission.storePermissionCheck
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import java.io.File

class VideoActivity : AppCompatActivity() {

    private lateinit var binding: ActivityVideoBinding
    private lateinit var videoAdapter: VideoSelectAdapter
    private lateinit var loadDialog: Dialog
    private lateinit var intentLauncher: IntentLauncher
    private lateinit var permissionLauncher: PermissionLauncher

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
        intentLauncher = IntentLauncher(this)
        permissionLauncher = PermissionLauncher(this)
        binding = ActivityVideoBinding.inflate(layoutInflater)
        setContentView(binding.root)
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main)) { v, insets ->
            val systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars())
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom)
            insets
        }
        window.statusBarColor = ContextCompat.getColor(this, R.color.color_C2F300)
        binding.ivArrow.setOnClickListener {
            finish()
        }
        videoAdapter = VideoSelectAdapter {
            binding.ivAll.isSelected = it
        }
        binding.ivAll.setOnClickListener {
            it.isSelected = videoAdapter.setToggleSelect()
        }
        binding.rv.layoutManager = GridLayoutManager(this, 3)
        binding.rv.adapter = videoAdapter

        if (storePermissionCheck()) {
            fileMode()
        } else {
            lockMode()
        }

        binding.tvDelete.setOnClickListener {
            val list = videoAdapter.getSelectFile()
            if (list.isEmpty()) return@setOnClickListener
            this.alert(
                "Currently selected ${list.size} items, are you sure to delete them",
                "Delete Confirm"
            ) {
                positiveButton("confirm") { dialog ->
                    deleteFiles(list)
                    dialog.dismiss()
                }
                negativeButton("cancel") { dialog ->
                    dialog.dismiss()
                }
                //禁止取消
                isCancel(false)
            }
        }
    }

    private fun lockMode() {
        binding.clLock.visibility = View.VISIBLE
        binding.clShow.visibility = View.GONE

        binding.tvSet.setOnClickListener {
            this.requestStoreFollow(
                permissionLauncher,
                intentLauncher,
                disAgreeAction = {
                    lockMode()
                },
                agreeAction = {
                    fileMode()
                })
        }
    }

    private fun fileMode() {
        binding.clLock.visibility = View.GONE
        binding.clShow.visibility = View.VISIBLE

        loadDialog = showLoadingDialog()
        loadVideoData()
    }

    private fun deleteFiles(files: List<MediaDataC>) = Thread {
        try {
            files.forEach {
                val file = File(it.path)
                if (file.exists()) {
                    if (file.isFile) file.delete() else deleteDirectory(file)
                }
            }
            lifecycleScope.launch(Dispatchers.Main) {
                val dialog = showOperationDialog(R.mipmap.dads_889562, "delete success!") {}
                delay(200)
                dialog.dismiss()
                videoAdapter.removeData(files)
            }
        } catch (e: Exception) {
            e.printStackTrace()
            runOnUiThread {
                toast("delete failed")
            }
        }
    }.start()

    private fun loadVideoData() {
        videoFile(this,
            onDoAction = { list ->
                runOnUiThread {
                    loadDialog.dismiss()
                    videoAdapter.addData(list)
                }
            },
            finishAction = {
                loadDialog.dismiss()
                runOnUiThread { isEmptyUi() }
            })
    }

    private fun isEmptyUi() {

        val count = videoAdapter.itemCount
        if (count == 0) {
            binding.rv.visibility = View.GONE
            binding.tvDelete.visibility = View.GONE
            binding.ivEmpty.visibility = View.VISIBLE
        } else {
            binding.rv.visibility = View.VISIBLE
            binding.tvDelete.visibility = View.VISIBLE
            binding.ivEmpty.visibility = View.GONE
        }

    }
}